version: '3.2'

services:
  client:
    container_name: my-app
    image: homework-4_front
    build:
      context: ./my-app
      dockerfile: Dockerfile
    volumes:
      - './my-app:/my-app'
      - '/my-app/node_modules'
    ports:
      - "3000:3000"
    expose:
      - 3000
    depends_on:
      - server
    networks:
      - webnet

  server:
    image: homework-4_server
    container_name: hw-server
    build:
      context: ./hw
      dockerfile: Dockerfile
    env_file:
      - ./hw/.env
    ports:
      - "3001:3001"
    expose:
      - 3001
    networks:
      - webnet
    depends_on:
      - db
    volumes:
      - ./hw/:/hw/
      - /hw/node_modules
    environment:
      - APP_PORT=3001
      - SERVER_JWT_SECRET=secret
      - MYSQL_PORT=3306
      - MYSQL_USER=root
      - MYSQL_PASSWORD=9xUsjvwsb5t
      - MYSQL_DATABASE=homework
      - MYSQL_HOST=db

  db:
    image: mysql:5.7
    container_name: homework-4_db
    restart: always
    platform: linux/x86_64
    command: --default-authentication-plugin=mysql_native_password
    environment:
      MYSQL_ROOT_PASSWORD: 9xUsjvwsb5t
      MYSQL_DATABASE: homework
    ports:
      - 3306:3306
    expose:
      - 3306
    volumes:
      - my-db:/var/lib/postgres
    networks:
      - webnet

  siege:
    image: siege
    container_name: homework-4_siege
    build:
      context: ./siege
      dockerfile: Dockerfile
    depends_on:
      - client
    networks:
      - webnet

volumes:
  my-db:

networks:
  webnet:
    driver: bridge
